CBTimelessIsleChest = LibStub("AceAddon-3.0"):NewAddon("CBTimelessIsleChest", "AceConsole-3.0", "AceEvent-3.0")

local nodes = { }
nodes[1] = { 951, 33170, 36.7, 34.1, "One-Time Chest 000" }
nodes[2] = { 951, 33171, 25.5, 27.2, "One-Time Chest 001" }
nodes[3] = { 951, 33172, 27.4, 39.1, "One-Time Chest 002" }
nodes[4] = { 951, 33173, 30.7, 36.5, "One-Time Chest 003" }
nodes[5] = { 951, 33174, 22.4, 35.4, "One-Time Chest 004" }
nodes[6] = { 951, 33175, 22.1, 49.3, "One-Time Chest 005" }
nodes[7] = { 951, 33176, 24.8, 53.0, "One-Time Chest 006" }
nodes[8] = { 951, 33177, 25.7, 45.8, "One-Time Chest 007" }
nodes[9] = { 951, 33178, 22.3, 68.1, "One-Time Chest 008" }
nodes[10] = { 951, 33179, 26.8, 68.7, "One-Time Chest 009" }
nodes[11] = { 951, 33180, 31.0, 76.3, "One-Time Chest 010" }
nodes[12] = { 951, 33181, 35.3, 76.4, "One-Time Chest 011" }
nodes[13] = { 951, 33182, 38.7, 71.6, "One-Time Chest 012" }
nodes[14] = { 951, 33183, 39.8, 79.5, "One-Time Chest 013" }
nodes[15] = { 951, 33184, 34.8, 84.2, "One-Time Chest 014" }
nodes[16] = { 951, 33185, 43.6, 84.1, "One-Time Chest 015" }
nodes[17] = { 951, 33186, 47.0, 53.7, "One-Time Chest 016" }
nodes[18] = { 951, 33187, 46.7, 46.7, "One-Time Chest 017" }
nodes[19] = { 951, 33188, 51.2, 45.7, "One-Time Chest 018" }
nodes[20] = { 951, 33189, 55.5, 44.3, "One-Time Chest 019" }
nodes[21] = { 951, 33190, 58.0, 50.7, "One-Time Chest 020" }
nodes[22] = { 951, 33191, 65.7, 47.8, "One-Time Chest 021" }
nodes[23] = { 951, 33192, 63.8, 59.2, "One-Time Chest 022" }
nodes[24] = { 951, 33193, 64.9, 75.6, "One-Time Chest 023" }
nodes[25] = { 951, 33194, 60.2, 66.0, "One-Time Chest 024" }
nodes[26] = { 951, 33195, 49.7, 65.7, "One-Time Chest 025" }
nodes[27] = { 951, 33196, 53.1, 70.8, "One-Time Chest 026" }
nodes[28] = { 951, 33197, 52.7, 62.7, "One-Time Chest 027" }
nodes[29] = { 951, 33227, 61.7, 88.5, "One-Time Chest 028" }
nodes[30] = { 951, 33198, 44.2, 65.3, "One-Time Chest - Stump Center" }
nodes[31] = { 951, 33199, 26.0, 61.4, "One-Time Chest - Stump SW Shore" }
nodes[32] = { 951, 33200, 24.6, 38.5, "One-Time Chest - Stump West" }
nodes[33] = { 951, 33202, 29.7, 31.8, "One-Time Chest - Steam Shore" }
nodes[34] = { 951, 33201, 59.9, 31.3, "One-Time Chest - Ordo Lake Lower" }
nodes[35] = { 951, 33203, 46.7, 32.3, "One-Time Chest - Cavern of Lost Spirits/In Cave" }
nodes[36] = { 951, 33205, 26.8, 64.9, "One-Time Chest - Carry Bird 1" }
nodes[37] = { 951, 33204, 28.2, 35.2, "One-Time Chest - Carry Bird 2" }
nodes[38] = { 951, 33206, 64.6, 70.4, "One-Time Chest - Gulp Frogs" }
nodes[39] = { 951, 33207, 59.2, 49.5, "One-Time Chest - Hammer Cavern" }
nodes[40] = { 951, 33208, 69.5, 32.9, "One-Time Chest - Ordo Chest 000" }
nodes[41] = { 951, 33209, 54.0, 78.2, "One-Time Chest - Ordo Chest 001" }
nodes[42] = { 951, 33210, 47.6, 27.6, "One-Time Chest - Blazing Chest" }

-- Weekly Chests
-- Extreme Treasure Hunter
nodes[43] = { 951, 32969, 49.7, 69.4, "Gleaming Treasure Chest", 1 }
nodes[44] = { 951, 32968, 54.0, 47.2, "Rope-Bound Treasure Chest", 1}
nodes[45] = { 951, 32971, 58.7, 60.1, "Mist-Covered Treasure Chest", 1 }

-- Where There's Pirates, There's Booty
nodes[46] = { 951, 32957, 40.0, 92.0, "Sunken Treasure", 1 }
nodes[47] = { 951, 32956, 17.2, 57.3, "Blackguard's Jetsam", 1 }
nodes[48] = { 951, 32970, 71.3, 80.0, "Gleaming Treasure Satchel", 1 }

function CBTimelessIsleChest:OnInitialize()
 self:RegisterEvent("PLAYER_ENTERING_WORLD", "WorldEnter")
 
 local defaults = {
  profile = {
   alwaysshow = false,
   save = true,
   icon = 6,
  },
 }

 self.db = LibStub("AceDB-3.0"):New("CBTimelessIsleChestsDB", defaults, true)
end

function CBTimelessIsleChest:WorldEnter()
 self:UnregisterEvent("PLAYER_ENTERING_WORLD")
 
 self:PopulateNotes()
end

function CBTimelessIsleChest:PopulateNotes()
 local icon = self.db.profile.icon or 6
 for k, v in pairs(nodes) do
  -- Nodes: MapID, QuestID, X Coord, Y Coord, QuestName, isDaily
  -- AddonNote: folder, name, icon, id, x, y
  if (not self:HasBeenLooted(v)) then
   Nx.Notes:AddonNote("TimelessIsle Chests", v[5], icon, v[1], v[3], v[4])
  end
 end
end

function CBTimelessIsleChest:HasBeenLooted(value)
 if (self.db.profile.alwaysshow) then return false end
 
 if (self.db.char[value[2]] and self.db.profile.save) then return true end
 
 if (IsQuestFlaggedCompleted(value[2])) then
  if (self.db.profile.save and not value[6]) then  -- Save the chest but not if it's a daily
   self.db.char[value[2]] = true;
  end
  
  return true
 end
  
 return false
end